---------------------------
-- ffD_1
---------------------------

library ieee;
use ieee.std_logic_1164.all;

entity ffD_1 is
  generic(
    td_g: time :=100 ns);
  port(
    d_p:   in  std_logic;
    clk_p: in  std_logic;
    q_p:   out std_logic);
begin
end entity ffD_1;

architecture beh of ffD_1 is
begin
  ff: process(clk_p) begin
    if (rising_edge(clk_p)) then
      q_p <= d_p;
    end if;
  end process;
end architecture beh;


---------------------------
-- ffD_1_t
---------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_textio.all;
use std.textio.all;

entity ffD_1_t is
end entity ffD_1_t;

architecture test of ffD_1_t is
  signal in1 : std_logic;
  signal out1: std_logic;

  signal clk: std_logic := '0';

  procedure printStatus is
    variable l:line;
  begin
	  write(l, now, right, 10, ns);
    write(l, string'(" in="));
    write(l, in1);
    write(l, string'(", clk="));
    write(l, clk);
    write(l, string'(" out="));
    write(l, out1);
    writeline(output, l);
  end procedure printStatus;

begin
  ffD1test: entity work.ffD_1(beh)
    generic map(
      td_g => 5 ns)
    port map (
      d_p   => in1,
      clk_p => clk,
      q_p   => out1);

  test: process 
    constant td:time := 200 ns;
  begin
    in1 <= '1'; 
    clk <= '0'; wait for td;
    printStatus;
    assert(out1='U') 
      report "test failed on clk=0";
    clk <= '1'; wait for td;
    printStatus;
    assert(out1='1') 
      report "test failed on clk=1";

    in1 <= '0'; 
    clk <= '0'; wait for td;
    printStatus;
    assert(out1='1') 
      report "test failed on clk=0";
    clk <= '1'; wait for td;
    printStatus;
    assert(out1='0') 
      report "test failed on clk=1";

    wait;
  end process test;

end architecture test;

