-------------------------------
-- ffD_n
-------------------------------

library IEEE;
use IEEE.Std_Logic_1164.all;

entity ffD_n is
  generic(
    cb_g: integer :=4;    -- count of bits
    td_g: time :=100 ns   -- delay
  ); port(
    d_p:   in  std_logic_vector(cb_g-1 downto 0);
    clk_p: in  std_logic;
    q_p:   out std_logic_vector(cb_g-1 downto 0)
  );
begin
end entity ffD_n;

architecture struct of ffD_n is
begin
  g_1 : for i in cb_g-1 downto 0 generate
  begin
    onebit: entity work.ffD_1(beh)
      generic map(
        td_g => td_g
      ) port map(
        d_p   => d_p(i),
        clk_p => clk_p,
        q_p   => q_p(i)
      );
  end generate; 
end architecture struct;

-------------------------------
-- ffD_n_test
-------------------------------

library IEEE;
use IEEE.Std_Logic_1164.all;
use std.textio.all;
use ieee.std_logic_textio.all;

entity ffD_n_t is
  constant cb:integer :=3;
begin
end entity ffD_n_t;

architecture test of ffD_n_t is
  signal din: std_logic_vector (cb-1 downto 0);
  signal dout: std_logic_vector (cb-1 downto 0);
  signal clk: std_logic := '0';

  procedure printStatus is
    variable l:line;
  begin
	  write(l, now, right, 10, ns);
    write(l, string'(" in: "));
    write(l, din);
    write(l, string'(" out: "));
    write(l, dout);
    writeline(output, l);
  end procedure printStatus;

begin
  uut: entity work.ffD_n(struct)
    generic map(
      cb_g => cb,
      td_g => 1 ns
    ) port map (
      d_p   => din,
      clk_p => clk,
      q_p   => dout
    );

  test: process 
    constant td:time := 200 ns;
  begin
    din <= "101"; 
    clk<='0';wait for td; 
    clk<='1';wait for td; 
    printStatus;
    assert(dout="101") 
      report "ffd_n test failed";

    din <= "010"; 
    clk<='0';wait for td; 
    clk<='1';wait for td; 
    printStatus;
    assert(dout="010") 
      report "ffd_n test failed";

    wait;
  end process test;

end architecture test;

